#!/bin/sh
#script para anunciar las reemisiones de programas.
#Utiliza ircha+mbrola|festival, grep, gawk, vorbiscomment, id2v2, tee, mplayer, find, tr, cut, sort, head y expr.
#El script es para todos los programas, y el nombre del archivo de programa (nombre_programa (sin ext.))
# lo pilla de la invocacion del comando y lo reproduce con text-to-speech (ircha+mbrola o festival).
#
#Si hoy = dia emision programa y archivo < 3 dias viejo y no enlace duro => no emite jingles, por lo que se 
# puede utilizar para reemitir los programas en todos los dias, tambien el dia de emision normal (y permitir
# que en caso de programas grabados exprofeso para ese dia no se anuncie que se va a emitir un programa "viejo").
#
#PROBLEMA: Hay delay entre las invocaciones de mplayer y las del text-to-speech.
# entonces a veces queda un pequeo silencio antes y despues del nombre del programa y de la fecha.
# La longitud del silencio depende de lo cacheado que este el programa en memoria (o algo).
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

NOMBREPROG=$*  #Es: nombre_programa (sin .ext)
#DIRPROGRAMAS=/home/martintxo/pruebas/garraxi
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
#DIRJINGLES=/home/martintxo/pruebas/garraxi
DIRJINGLES=/home/garraxi/Biltegi/Kunyas/jingles
#CONFIGPROGRAMAS=/home/martintxo/pruebas/config-programas3.txt
CONFIGPROGRAMAS=/home/garraxi/.programas-radio/config-programas.txt
#MUSICAVARIADA="/home/martintxo/MISDOCS/Misdocumentos/Multimierda/Musica/musica/James Brown"
MUSICAVARIADA="/home/garraxi/Biltegi/Musica/RTL Ultimative Chart Show - Varios artistas"

### Solventar bugs de Soma (quitarlo cuando se arreglen los bugs):
###  1. Si no hay archivo de programa hay silencio en la transmision
# Busca musica variada para rellenar transmision y que sea imposible que haya silencio:
noprograma()
{
 #Saco musica variada de carpeta RTL, donde cancion mas corta = 2:35 min. => 15 canciones cortas ~= 40 min, (duracion transmision)
 find "$MUSICAVARIADA" -maxdepth 1 -type f \( -iname '*.ogg' -o -iname '*.mp3' \) | rl -c 15 > /tmp/reemision-playlist.txt
 echo "Emitiendo msica variada, en lugar del programa $NOMBREPROG (no encontrado)" | tee -a /var/log/soma/soma.log
 mplayer -ao esd,alsa, -msglevel avsync=5 -af volnorm=2:0.25 -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput -playlist /tmp/reemision-playlist.txt
 rm /tmp/reemision-playlist.txt
 exit
}
### FIN Solventar bug1 de Soma

#Para parsear correctamente los espacios en los nombres de archivo:
OLDIFS=$IFS
IFS=
#Busca algun (1 o varios) archivos de programa anterior en emision en el dir del programa:
PLAYLIST=`find "$DIRPROGRAMAS/Emision/$NOMBREPROG" -maxdepth 1 -type f \( -iname '*.ogg' -o -iname '*.mp3' \) -printf "%s%p$IFS"`

#1. Si no encuentra archivo de programa a emitir (bug soma 1.)
if  [ "$PLAYLIST" = "" ] ;then
   noprograma
fi

#Si encuentra varios archivos, saca el de mayor tamao y de el sacara la fecha a vocalizar, entre otras muchas cosas.
NOMBREPROGEXT=`echo "$PLAYLIST" | tr '' '\n' | sort -r -n | head -n 1 | cut -s -d '' -f 2`

#1. Si el archivo del programa a emitir no existe, o si existe pero tiene tamao 0 bytes (bug soma 1.)
if  [ ! -f "$NOMBREPROGEXT" ] || [ ! -s "$NOMBREPROGEXT" ] ;then
   noprograma
fi

#Pone los archivos encontrados, ordenados alfanumericamente, en una playlist para mplayer
echo "$PLAYLIST" | tr '' '\n' | cut -s -d '' -f 2 | sort > /tmp/reemision-playlist.txt

### Solventar bugs de Soma (quitarlo cuando se arreglen los bugs):
###  2. Si duracion programa < duracion transmision (standar 40 min.), se repite el programa 
# Duracion del archivo de programa, en segundos
DURACION=`mplayer -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput -identify "$NOMBREPROGEXT" -ao null -vo null -frames 0 | grep -i "ID_LENGTH=" | cut -s -d "=" -f 2 | cut -s -d "." -f 1`

#Si mplayer no da la duracion del programa, no podra tocarlo => bug1 soma:
if [ "$DURACION" = "" ];then
 noprograma

#2. Si duracion de archivo de programa < 40 min (2400 seg) => cuantas canciones RTL de 2:35 min (155 seg) + 1 caben en la diferencia
elif [ "$DURACION" -lt "2400" ];then
 N=`expr \( \( 2400 - "$DURACION" \) / 155 \) + 1`
 #Saco $N canciones variadas y las _aado_ al final de la playlist del programa 
 find "$MUSICAVARIADA" -maxdepth 1 -type f \( -iname '*.ogg' -o -iname '*.mp3' \) | rl -c "$N" >> /tmp/reemision-playlist.txt
fi
### FIN Solventar bug2 de Soma

#Determina si el archivo es enlace duro (duplicado) (!=1)
DUPLICS=`stat -c %h "$NOMBREPROGEXT"`

#Parseo de la fecha de grabacion del programa:
#Si ogg, busca fecha del programa en comentarios de vorbis:
if echo "$NOMBREPROGEXT" | grep -i '.ogg' \
    && VORBISDATE=`vorbiscomment -l "$NOMBREPROGEXT" | grep -i "date" | cut -d "=" -f 2 -s` \
    && [ "$VORBISDATE" != "" ] ;then
 DIA=`echo "$VORBISDATE" | cut -d "/" -f 1 -s`
 MES=`echo "$VORBISDATE" | cut -d "/" -f 2 -s`
 AO=`echo "$VORBISDATE" | cut -d "_" -f 1 -s | cut -d "/" -f 3 -s`
 HORA=`echo "$VORBISDATE" | cut -d "_" -f 2 -s | cut -d ":" -f 1 -s`
 MINUTO=`echo "$VORBISDATE" | cut -d ":" -f 2 -s`

#Si mp3, busca la fecha en los id3 tags:
elif echo "$NOMBREPROGEXT" | grep -i '.mp3' \
      && MP3DATE=`id3v2 -l "$NOMBREPROGEXT" | grep -i "date" | cut -d " " -f 3 -s` \
      && [ "$MP3DATE" != "" ] ;then
 DIA=`echo "$MP3DATE" | cut -d "/" -f 1 -s`
 MES=`echo "$MP3DATE" | cut -d "/" -f 2 -s`
 AO=`echo "$MP3DATE" | cut -d "_" -f 1 -s | cut -d "/" -f 3 -s`
 HORA=`echo "$MP3DATE" | cut -d "_" -f 2 -s | cut -d ":" -f 1 -s`
 MINUTO=`echo "$MP3DATE" | cut -d ":" -f 2 -s`

#Si tags no fecha, busca fecha (formato 2008-03-19-23:59, el de prog. reemitido) en nombre archivo:
elif NAMEDATE=`basename "$NOMBREPROGEXT" | grep -o '[0-9]\{4\}-[0-9]\{2\}-[0-9]\{2\}-[0-9]\{2\}:[0-9]\{2\}'`;then
 DIA=`echo "$NAMEDATE" | cut -d "-" -f 3 -s`
 MES=`echo "$NAMEDATE" | cut -d "-" -f 2 -s`
 AO=`echo "$NAMEDATE" | cut -d "-" -f 1 -s`
 HORA=`echo "$NAMEDATE" | cut -d ":" -f 1 -s | cut -d "-" -f 4 -s`
 MINUTO=`echo "$NAMEDATE" | cut -d ":" -f 2 -s`

else
#En otro caso lee la fecha del programa de la fecha de ultimo acceso del archivo
# (ver discusion sobre fechas de archivos en info-software-garraxi3.txt):
 OTHERDATE=`stat -c %x "$NOMBREPROGEXT"`
 DIA=`echo "$OTHERDATE" | cut -d " " -f 1 -s | cut -d "-" -f 3 -s`
 MES=`echo "$OTHERDATE" | cut -d "-" -f 2 -s`
 AO=`echo "$OTHERDATE" | cut -d "-" -f 1 -s`
 HORA=`echo "$OTHERDATE" | cut -d " " -f 2 -s | cut -d ":" -f 1 -s`
 MINUTO=`echo "$OTHERDATE" | cut -d ":" -f 2 -s`
fi
 
#Formatea la fecha a vocalizar en $FECHA, segun el dia de la semana en que se emitio y el tiempo que ha pasado:

#Variables para sacar dia semana. Utilizo "segundos desde 1970" (+%s) para evaluar el tiempo pasado desde
# la grabacion del programa porque con dias del ao (%j) la resta da errores con valores como 009 (9 enero) 
# o 089 (29 marzo) y asi con muchos dias. Tb. por bug al final de ao y principio del nuevo que no se puede
# evaluar bien cuantos dias han pasado con dia del ao.
HOYSECS=`date +"%s"`
SECSPROG=`date --date=""$AO"-"$MES"-"$DIA" "$HORA":"$MINUTO"" +"%s"`
((RESTA="$HOYSECS"-"$SECSPROG"))

HOYDIASEMANA=`export LANG=es_ES && date +"%A"`
#Busca dia_emision de programa en $CONFIGPROGRAMAS 
DIAEMISION=`grep -v "^#" "$CONFIGPROGRAMAS" | grep -i -A 5 "$NOMBREPROG" - | grep -i "Dia:" - | cut -s -d " " -f 2`

#Si programa no enlace duro, =< 3 dias viejo (259200 seg) y hoy = dia emision programa => no jingle, solo reemision:
if [ "$DUPLICS" = "1" ] && [ "$RESTA" -le "259200" ] && [ "$HOYDIASEMANA" = "$DIAEMISION" ];then
 echo "Emitiendo: $NOMBREPROG" | tee -a /var/log/soma/soma.log
 mplayer -ao esd,alsa, -msglevel avsync=5 -af volnorm=2:0.25 -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput -playlist /tmp/reemision-playlist.txt
 rm /tmp/reemision-playlist.txt
 exit

#Si programa es de ayer => es =< 36 horas aprox. (24 + 12) = 129600 segs (BUGGY: 47,9 horas tb puede ser ayer)
elif [ "$RESTA" -le "129600" ];then
 FECHA=`export LANG=es_ES && date --date="$AO""$MES""$DIA" +"Ayer %A, %e de %B del %Y."`
#Si programa de esta semana => es =< 24*7 horas (604800 seg) => el pasado dia ...
elif [ "$RESTA" -le "604800" ];then
 FECHA=`export LANG=es_ES && date --date="$AO""$MES""$DIA" +"El pasado %A, %e de %B del %Y."`
else
 FECHA=`export LANG=es_ES && date --date="$AO""$MES""$DIA" +"El %e de %B del %Y."`
fi

#Preprocesa $NOMBREPROG para meter espacios (vocalizacion se entiende mejor con palabras separadas) y punto final:
if  echo "$NOMBREPROG" | grep '_' > /dev/null ;then
 #Conversion de "_" a "espacio"
 NOMBREPROG2=`echo "$NOMBREPROG." | tr "_" " "`
else
 #Conversion de "mayuscula" a "espacio+mayuscula":
 NOMBREPROG2=`echo "$NOMBREPROG." | gawk '{ gsub (/[[:upper:]]/, " &"); print }'`
fi

#Devolver el separador standar de bash, por si acaso:
IFS=$OLDIFS

#Info de que va a tocar, a stadout y a soma.log:
echo "Emitiendo: jingle-reemisiones + $NOMBREPROG" | tee -a /var/log/soma/soma.log

############### Rutina de emision jingle + programa (no meter calculos dentro):

#No poner '-ao esd' a mplayer antes de ejecutar ircha (en todos casos). Usando esd, ircha se ejecuta pero no emite sonido.
#Reproduce archivo de sonido con contenido "Hola querido oyente ...":
mplayer -ao alsa, -msglevel avsync=5 -af volnorm=2:0.25 -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones1.ogg"

#Lee en voz alta el nombre del programa (ejemp: "Saltsa Berde."):
lee "$NOMBREPROG2" 2> /dev/null
#echo `echo "$NOMBREPROG2"` | festival --tts --language spanish

#Reproduce archivo de sonido con texto "...que fue emitido...":
mplayer -ao alsa, -msglevel avsync=5 -af volnorm=2:0.25 -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones2.ogg"

#Lee en voz alta la fecha del programa:
lee "$FECHA"  2> /dev/null
#echo "$FECHA" | festival --tts --language spanish

#Cortinilla final "Garraxi Irratia 101.9" + reemision del programa:
mplayer -ao alsa, -msglevel avsync=5 -af volnorm=2:0.25 -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones3.ogg" -playlist /tmp/reemision-playlist.txt

############### Fin rutina de emision continua

rm /tmp/reemision-playlist.txt

exit
